/**
 * Created by mgoria on 2/3/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.S3FsRumProxy = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Proxy S3FS library
 */
let S3FsRumProxy = exports.S3FsRumProxy = function () {
  /**
   * @param {Object} originalInstance
   * @param {Object} logService
   */
  function S3FsRumProxy(originalInstance, logService) {
    _classCallCheck(this, S3FsRumProxy);

    this._originalInstance = originalInstance;
    this._logService = logService;
  }

  /**
   * @returns {Object}
   */


  _createClass(S3FsRumProxy, [{
    key: 'proxy',
    value: function proxy() {
      var _this = this;

      let proxy = {};

      for (let property in this._originalInstance) {
        if (typeof this._originalInstance[property] === 'function') {
          let originalFunction = this._originalInstance[property];

          proxy[property] = function () {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            let originalCallback = null;

            // seeking the callback function through the arguments and proxy it
            args.forEach((arg, index) => {
              if (typeof arg === 'function') {
                originalCallback = arg;

                args[index] = function () {
                  var _originalCallback;

                  for (var _len2 = arguments.length, cbArgs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                    cbArgs[_key2] = arguments[_key2];
                  }

                  _this._logRumEvent({
                    eventName: property,
                    payload: { args: cbArgs }
                  });

                  return (_originalCallback = originalCallback).call.apply(_originalCallback, [_this._originalInstance].concat(cbArgs));
                };
              }
            });

            // proxy only async methods (that have a callback through args)
            if (null !== originalCallback) {
              _this._logRumEvent({
                eventName: property,
                payload: { args: args }
              });
            }

            return originalFunction.call.apply(originalFunction, [_this._originalInstance].concat(args));
          };
        } else {
          proxy[property] = this._originalInstance[property];
        }
      }

      return proxy;
    }

    /**
     * @param {Object} customData
     */

  }, {
    key: '_logRumEvent',
    value: function _logRumEvent(customData) {
      let event = _util2.default._extend(customData, {
        service: 'deep-fs',
        resourceType: 'S3',
        resourceId: this._originalInstance.bucket
      });

      this._logService.rumLog(event);
    }
  }]);

  return S3FsRumProxy;
}();