/**
 * Created by mgoria on 6/10/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnknownFolderException = undefined;

var _Exception = require('./Exception');

/**
 * Thrown when unknown FS folder is requested
 */
class UnknownFolderException extends _Exception.Exception {
  /**
   * @param {String} folderName
   * @param {Array} folders
   */
  constructor(folderName, folders) {
    super(`Unknown folder "${folderName}". Defined folders are "${folders.join(', ')}"`);
  }
}
exports.UnknownFolderException = UnknownFolderException;